#ifndef __buffedit__
#define __buffedit__

#include "danStuff.h"

typedef enum buffEdEvent_e  { EV_NOP = 0, EV_CRS_FWD, EV_CRS_BCK, EV_OVERWR, EV_INSERT, EV_CRS_START, EV_CRS_END, EV_DELETE, EV_BACKSP, EV_SELRIGHT, EV_SELLEFT, EV_LAST } buffEdEvent_t;

typedef struct buffEdProc_s {
   char *        buff;
   unsigned int  cursor;
   unsigned int  maxlen;
} buffEdProc_t;

void buffEdInit( buffEdProc_t * this ) ;
void buffEdFini(buffEdProc_t * this ) ;
void buffEdTakeStroke( buffEdProc_t * this , buffEdEvent_t cmd,  char c) ;





#endif
