/****************************************************************

 The idea of this is that you have something that can load a file
  of any type into a generic format buffer. This version is a 
  direct load used for text files.

Method summary:

   int LoadFile( Accumulator * buffer, char * fileName);
 //int SaveFile( Accumulator * buffer, char * fileName); // Later...
 

 ????       dan, created 
 mar 05 2002 dan, switched to class from header
 jul 05 2002 dan, using new accumulator methods.
 aug 02 2002 dan, added save method
 dec 08 2011 dan, converted to C
 

****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "filefilter.h"


/************************************

Load a file into the given Accumulator

I think I know why streams were invented.

In:  
  buffer   An Accumulator to load into.
  FileName The path/filename of a file to load.
  
Out: 
  0 = failure right now I dont care why it failed.
  1 = success

************************************/

Status_t FF1LoadFile( tac_t * buffer, char * FileName ){

  FILE *input;
  long fsize;
  long vol;
  size_t chunk;
  char  tempBuff[1026];
  
  
  //open file
  if (( input = fopen ( FileName, "rb" )) == NULL) { 
      printf("Unable to open %s for input.\n", FileName);
      return CantOpen;
  }

  // get file size
  fseek ( input, 0,  SEEK_END);
  fsize = ftell ( input );

   // copy it into the buffer
  fseek ( input, 0, SEEK_SET );
  
  for(vol = fsize; vol > 0; ) {
    vol -= (chunk = fread(tempBuff, 1, 1024, input));
    TACSetN(buffer, buffer->contentSize - 1, 0, tempBuff, chunk); 
   // printf("%d bytes\n", chunk);
  }
 // TACSetN(buffer, buffer->contentSize - 1, 0, "\0", 1); // null termination, ironic...

  //close file
  fclose ( input );
  return OK;

}

Status_t FF1SaveFile( tac_t * buffer, char * FileName ){

 FILE *output;
 char tempBuff[1026];
 long   vol;
 long chunk;

  //printf("EEEk, your calling the untested file write function!\n"); // sigh...

  //open file
  if (( output = fopen ( FileName, "w+b" )) == NULL) { 
      printf("Unable to open %s for output. bailing\n", FileName);
      return CantOpen;
  }

   vol      = 0;
  // tac_t * this, AOffset_t position, char * buffer, AOffset_t size, AOffset_t * returnSize );
  do {
    TACReadN( buffer, vol, tempBuff, 1024, &chunk); // !!!???!!!! errors!
    vol += chunk;
  //  printf("chunk is %ld\n", chunk);
    fwrite( &tempBuff, 1, chunk, output ); 
  } while(chunk > 0);
  
  //close file
  fclose ( output );
  
  return OK;

  
}
	
