/***************************************************************

 This is for content specific navigation.
  

 Dan, <Feb 19, 2002>
 dan < nov 29,2002 > created from contentfilter.
 dan < feb 8, 2021 > added FwdLines and BackLines, made Next and Prev compt. shells.

***************************************************************/

#ifndef _NAVIGATOR

#define _NAVIGATOR

  #include "accumulator.h"
  #include "cestypes.h"
  
  typedef struct Nav_s {  
    tac_t * accumulator ;
  } Nav_t;
  
  void      NavInit           ( Nav_t * this);
  void      NavFini           ( Nav_t * this);
  void      NavSetAccumulator ( Nav_t * this, tac_t * accum);
  ChrOffset NavLinePos        ( Nav_t * this, ChrOffset position);
  ChrOffset NavLineEnd        ( Nav_t * this, ChrOffset position);
  ChrOffset NavNextLine       ( Nav_t * this, ChrOffset position);
  ChrOffset NavPrevLine       ( Nav_t * this, ChrOffset position);
  ChrOffset NavFwdLines       ( Nav_t * this, ChrOffset position, unsigned int lines);
  ChrOffset NavBackLines      ( Nav_t * this, ChrOffset position, unsigned int lines);
  ChrOffset NavLineLength     ( Nav_t * this, ChrOffset position);
  ChrOffset NavXY2Offset      ( Nav_t * this, unsigned int X, unsigned int Y);

#endif
